#include <iostream>
#include <vector>
#include <math.h>
using namespace std;

int main()
{
    //
    size_t number_count;
    size_t bin_count;
    float n = 0;

    cerr << "Enter number count: ";
    cin >> number_count;

    vector<double> numbers(number_count);


    for (size_t i = 0; i<number_count;i++) {
        cerr << "Enter number " << i+1 << ": ";
        cin >> numbers[i];}
    cerr << "Enter bin count: ";
    cin >> bin_count;

    if (bin_count==0){
        bin_count = sqrt(number_count);
        n = 1;
        if (bin_count > 25){
            bin_count = 1 + log2(number_count);
            n = 2;}}

    vector<double> bins(bin_count);

    //



    double min = numbers[0];
    double max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }
    double bin_size = (max - min) / bin_count;

    for (size_t i = 0; i < number_count; i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }
    }

    //
    if (n != 0){
        cout << "bin count = " << bin_count;
        if (n == 1)
            cout << " using 1st" << '\n';
        else
            cout << " using 2nd" << '\n';}
    for (size_t i = 0; i < bin_count; i++) {
        if (bins[i]<100)
            cout << " ";
        if (bins[i]<10)
            cout << " ";
        cout << bins[i] << "|";
        for (size_t j = 0; j < bins[i]; j++){
            cout << "*";}
        cout << '\n';}
    return 0;
}
